﻿using Dicom.Network;
using NLog;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reactive.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DicomClient = Dicom.Network.Client.DicomClient;
using System.Reactive.Threading.Tasks;
using System.CodeDom;
using C_UI.Models;

namespace C_UI
{

    public static class SCU_Store
    {

        static Logger logger = LogManager.GetCurrentClassLogger();
        public static async Task StoreFile(InputsDto inputsDto)
        {
            var client = new DicomClient(inputsDto.ServerHost, inputsDto.Port, false, inputsDto.ServerAET, inputsDto.Aet);
            client.NegotiateAsyncOps();
            inputsDto.FileNames.ToObservable()
                .Select(fileName => Observable.FromAsync(async () =>
                 {
                     var request = new DicomCStoreRequest(fileName);
                     request.OnResponseReceived += (req, response) => logger.Info($"{response.Status}-{fileName}");
                     await client.AddRequestAsync(request);
                     await client.SendAsync();
                 }).Select(x => fileName).Catch<string, Exception>(exp => throw new Exception($"failed to send: {fileName}, with error:{exp.Message}")))
                .Concat()
                .Subscribe(
                    filename =>
                        logger.Warn($"file sent:{filename}"),
                    onError =>
                        logger.Error(onError.Message),
                    () => { });
        }
    }
}
